
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;

/**
 * ۉꂽ\c[LbgENXł <br>
 * WnɂāA_(0, 0)ɂȂ悤ɓIɓǑւs܂B
 */

public class DrawImageToolkit {
	/**
	 * SWTAvP[V
	 */
	private SwtApplication swtapp = null;

	/**
	 * `ΏۂƂȂImageIuWFNg
	 */
	private Image image = null;

	/**
	 * `̈̉
	 */
	private int sizeDrawingAreaX = 0;

	/**
	 * `̈̏c
	 */
	private int sizeDrawingAreaY = 0;

	/**
	 * `̍ۂɗp GCIuWFNg
	 */
	private GC gc = null;

	/**
	 * ftHgRXgN^̗p͔F߂܂B
	 */
	private DrawImageToolkit() {
	}

	/**
	 * \pImagec[Lbg̃CX^X쐬܂B <br>
	 * ̃^C~OGCIuWFNg܂B <br>
	 * 
	 * @param swtapp
	 *            SWTAvP[ṼCX^XB
	 * @param image
	 *            C[WIuWFNg
	 * @param sizeX
	 *            `̈̉
	 * @param sizeY
	 *            `̈̏c
	 */
	public DrawImageToolkit(SwtApplication swtapp, Image image, int sizeX,
			int sizeY) {
		this.swtapp = swtapp;
		this.sizeDrawingAreaX = sizeX;
		this.sizeDrawingAreaY = sizeY;
		this.image = image;
		gc = new GC(image);
	}

	/**
	 * `ReLXg擾܂B
	 * 
	 * @return IɕێĂ`ReLXg
	 */
	public GC getGC() {
		return gc;
	}

	/**
	 * N[Y܂B傽ړI͕`ReLXg̉łB <br>
	 * close()͖YꂸɌĂяoĂB
	 */
	public void close() {
		if (gc != null) {
			gc.dispose();
			gc = null;
		}
	}

	/**
	 * \܂B
	 * 
	 * @param startX
	 * @param startY
	 * @param endX
	 * @param endY
	 */
	public void drawLine(int startX, int startY, int endX, int endY) {
		gc.drawLine(startX, sizeDrawingAreaY - startY, endX, sizeDrawingAreaY
				- endY);
		boolean isError = false;
		if (startX < 0 || startX > sizeDrawingAreaX) {
			isError = true;
		}
		if (startY < 0 || startY > sizeDrawingAreaY) {
			isError = true;
		}
		if (isError) {
			System.err.println("drawLine(" + startX + ", " + startY + ", "
					+ endX + ", " + endY + ") \\͈͂𒴂Ă܂B");
		}
	}

	/**
	 * eLXg\܂B <br>
	 * ̖߂ĂԑOɕKvɉătHgݒ肵ĂB
	 * 
	 * @param text
	 *            \eLXg
	 * @param x
	 *            \WX
	 * @param y
	 *            \WY
	 */
	public void drawText(String text, int x, int y) {
		gc.drawText(text, x, sizeDrawingAreaY - y);

	}

	/**
	 * lp\܂BhԂ͍s܂B
	 * 
	 * @param x
	 * @param y
	 * @param width
	 * @param height
	 */
	public void drawRectangle(int x, int y, int width, int height) {
		// ̕`ɂāAL̂悤ȑKvɂȂ܂c
		gc.drawRectangle(x, sizeDrawingAreaY - y + 1, width, -height - 2);

		boolean isError = false;
		if (x < 0 || x > sizeDrawingAreaX) {
			isError = true;
		}
		if (y < 0 || y > sizeDrawingAreaY) {
			isError = true;
		}
		if (x + width < 0 || x + width > sizeDrawingAreaX) {
			isError = true;
		}
		if (y + height < 0 || y + height > sizeDrawingAreaY) {
			isError = true;
		}
		if (isError) {
			System.err.println("drawRectangle(" + x + ", " + y + ", " + width
					+ ", " + height + ") \\͈͂𒴂Ă܂B");
		}
	}

	/**
	 * lphԂȂ`悵܂B
	 * 
	 * @param x
	 * @param y
	 * @param width
	 * @param height
	 */
	public void fillRectangle(int x, int y, int width, int height) {
		gc.fillRectangle(x, sizeDrawingAreaY - y, width, -height);

		boolean isError = false;
		if (x < 0 || x > sizeDrawingAreaX) {
			isError = true;
		}
		if (y < 0 || y > sizeDrawingAreaY) {
			isError = true;
		}
		if (x + width < 0 || x + width > sizeDrawingAreaX) {
			isError = true;
		}
		if (y + height < 0 || y + height > sizeDrawingAreaY) {
			isError = true;
		}
		if (isError) {
			System.err.println("fillRectangle(" + x + ", " + y + ", " + width
					+ ", " + height + ") \\͈͂𒴂Ă܂B");
		}
	}

	/**
	 * Ot𗘗pۂɕ֗ȊiqObh\܂B
	 * 
	 * @param grid_pixel_step
	 *            Obh(iq)̃XebvP ڈ=50
	 * @param rate_par_pixel
	 *            lsNZɕϊۂ̃[g (sNZ̒l̏d)
	 */
	public void drawGrid(int grid_pixel_step, int rate_par_pixel) {
		for (int index = 0;; index++) {
			int y = 10 + grid_pixel_step * index;
			if (y >= sizeDrawingAreaY) {
				break;
			}

			gc.setBackground(swtapp.getDisplay()
					.getSystemColor(SWT.COLOR_WHITE));
			gc.setForeground(swtapp.getDisplay()
					.getSystemColor(SWT.COLOR_BLACK));
			drawLine(100, y, sizeDrawingAreaX - 50, y);

			// Ot̃\܂B
			drawText(String.valueOf(index * grid_pixel_step * rate_par_pixel),
					50, y + 10);
		}
	}
}